nde-style-style 基于adwaita-qt-1.1.1，保留主体框架，修改控件绘制部分以达到Materail Design的风格
==========

## 编译和运行

1. 使用QtCreator打开CmakeList.txt之后(确保cmake配置成功)，在项目-->Build->构建配置中，将![BUILD_EXAMPLE](demo.jpg)打开
2. 在项目-->Run->运行设置中，将![部署](deploy.jpg)配置好。请修改图中sudo秘密为自己机器密码。
3. 点击QtCreator运行按钮，可以运行当前正在修改的style的demo程序。

## 开发

1. 当前水波动画已经实现,当前只在button上点击有水波效果.请运行例子查看.其他组件需要水波动画请参照button实现.如果一个组件还有别的动画效果或者默认的水波效果不满足,请继承MaterialRipple,实现自己的动画.
2. 后续开发任务主要集中在ndestylestyle.cpp,ndestylehelper.cpp,动画增加三部分.
3. 根据![设计](style.png),修改Style类中的drawControl,drawPrimitive,drawComplexControl等对应组件的绘制函数.比如按钮绘制,大致可以分为四部分,可以按照这个模式来实现其他控件
```C++
// 1.获取对应Option
    const QStyleOptionButton *buttonOption(qstyleoption_cast< const QStyleOptionButton * >(option));
    if (!buttonOption)
        return true;

    // rect and palette
    const QRect &rect(option->rect);

    // 2.计算状态
    const State &state(option->state);
    bool enabled(state & State_Enabled);
    bool windowActive(state & State_Active);
    bool mouseOver((state & State_Active) && enabled && (state & State_MouseOver));
    bool hasFocus((enabled && (state & State_HasFocus)) && !(widget && widget->focusProxy()));
    bool sunken(state & (State_On | State_Sunken));
    bool flat(buttonOption->features & QStyleOptionButton::Flat);

    qreal opacity(1);
    AnimationMode mode = AnimationFocus;
    
    if (flat) {
        //3.获取状态对应的颜色
        const QPalette &palette(option->palette);
        QColor color(_helper->toolButtonColor(palette, mouseOver, hasFocus, sunken, opacity, mode));
        //4.绘制
        _helper->renderToolButtonFrame(painter, rect, color, sunken);
    } else {
        //3.获取状态对应的颜色
        QPalette palette(option->palette);
        QColor shadow(palette.color(QPalette::Shadow));
        QColor outline(_helper->buttonOutlineColor(palette, mouseOver, hasFocus, opacity, mode, _dark));
        QColor background(_helper->buttonBackgroundColor(palette, mouseOver, hasFocus, sunken, opacity, mode, _dark));
        //4.绘制
        _helper->renderButtonFrame(painter, rect, background, outline, shadow, hasFocus, sunken, mouseOver, enabled && windowActive, _dark);
    }
    //绘制水波动画
    if(enabled){
        QList<RippleData> rippleDatas = _animations->widgetStateEngine().ripples(widget);
        foreach(RippleData data, rippleDatas){
            const QPointF center = data.center;
            painter->setOpacity(data.opacity);
            painter->setBrush(QColor("gray"));
            painter->drawEllipse(center, data.radius, data.radius);
        }
    }

    return true;
```
4. 颜色暂时直接从"设计"图中取,后续统一修改处理.
Material desgin颜色调色板,放到了nde-lib库中,需要编译安装这个库之后在编译nde-style-style库
1.首先找到nde-lib目录下的nde-lib.spec,使用sudo yum-builddep nde-lib.spec安装依赖.
2. cmake 编译和安装.
3.编译newstat-style,后续颜色相关获取使用类MaterialStyle类.
